(*:Copyright: Copyright 1988-2003 Wolfram Research, Inc. *)

(*:Mathematica Version: 3.0 *)

(*:Package Version: 1.0 *)

(*:Name: Algebra`General` *)

(*:Title: Generalities *) 

(*:Author: Cndido Martn Gonzlez *)

(*:Keywords: Common commands for dealing with algebras *)

(* :Sources: Russian's book: Rings that are nearly associative*)

(*:Summary: Common commands for dealing with algebras*)

BeginPackage["Algebra`General`"]

delta::usage="Kronecker Delta."

asigna::usage="Internal function."

Base::usage="Gives a set spanning the space."

diag::usage="Diagonal of matrix."

dim::usage="Dimension of a generic element in a subspace gives the number of parameters 
involved in the element. If the element is well chosen, then it gives the dimension of the 
space."

Begin["Algebra`General`Private`"]
 
diag[x_]:=Table[x[[i,i]],{i,Length[x]}]

dim[x_]:=Length[Variables[x]]

delta[i_,j_]:=If[i==j,1,0]   

asigna[i_, l_] := 
      Table[l[[j]]->delta[i,j], {j, Length[l]}]
      
      Base[x_]:=Module[{n},
      n=Variables[x];
      Table[(x//.asigna[i,n]),{i,Length[n]}]
                      ]

End[]  (* Algebra`General`Private` *)


EndPackage[]  (* Algebra`General` *)

            

